import es
import re
def load():
    es.regcmd("es_token", "corelib/legacystring/es_token", "Set a variable to a particular token in the string.\n Syntax: es_xtoken <variable> <string> [token#] [tokenchar]")
    es.regcmd("es_xtoken", "corelib/legacystring/es_xtoken", "Set a variable to a particular token in the string. Doesn't expand EventScripts variables.\n Syntax: es_xtoken <variable> <string> [token#] [tokenchar]")


def es_token():
    args = es.getargs()
    es.server.cmd("es es_xtoken %s" % args)

def es_xtoken():
    argc = es.getargc()
    if argc <= 5 and argc >=3:
        varname = es.getargv(1)
        if not es.exists('variable', varname):
            es.dbgmsg(0, "es_xtoken: The variable %s does not exist." % varname)
            return
        seps = ''
        if argc == 5:
            seps = es.getargv(4)
        if argc == 4:
            seps = " "
        text = es.getargv(2)
        foo = text.split(seps)
        returnvar = es.ServerVar(varname)
        try:
            tokenindex = int(es.getargv(3))
        except ValueError, e:
            es.dbgmsg(0, "Error: Invalid syntax for es_xtoken, integer required for argument 3: '%s' given", es.getargv(3))
            return
        if tokenindex == 0:
            returnvar.set(len(foo))
        else:
            tokenindex-=1
            if (tokenindex >= len(foo)) or (tokenindex < 0):
                es.dbgmsg(0, "The specified token number %d doesn't exist\n", param)
                return
            else:
                returnvar.set(foo[tokenindex])
